#include <dos/dos.h>
#include <exec/types.h>
#ifndef Prototype
#define Prototype extern
#endif

/*********************************************************************/
/*      Die Funktion OpenRexx ffnet, wenn mglich einen RexxPort.   */
/*********************************************************************/

/*
 * OpenRexx     initialisiert die ARexxumgebung. Dafr wird, wenn bentigt
 *      Arexxlibrary geffnet, ein Port initialisiert, die Defaultextension
 *      festgelegt und die std Ein- und Ausgabekanle bestimmt.
 *
 * --> name     Name des ARexxPorts den unser Programm bekommt.
 *              Existiert ein solcher Port bereits wird der FehlerCode
 *              ERROR_PORT_ALLREADY_EXISTS zurckgegeben
 * --> ext      Zeiger auf die extension, wenn NULL dan .REXX
 * --> do_res   Zeiger auf die Funktion zum Message handling.
 *              Wird aufgerufen wenn whrend der Arbeit ein RexxMsg anfllt
 * --> in,out   std input/output handle
 * <-- RESLUT   SigBit   Success FALSE wenn nicht geffnet
 */


/******************************************************************/
/*      beantwortet alle anstehenden Messages, mit RXRERRORIMGONE  */
/*      wartet auf alle noch zu beantwortenden Messages           */
/*      schliet den Port                                         */
/*      schliet die ArexxSysBase                                 */
/******************************************************************/


/********************************************************************/
/*      Mit dieser Funktion kann man den letzten aufegetreten       */
/*      FehlerCode festellen                                        */
/********************************************************************/


/****************************************************************/
/*      BuildRexxMsg erstellt eine ARexx Message und fllt      */
/*      die Argument slots mit den Parametern                   */
/****************************************************************/
/*
 *      Aufruf erfolgt: BuildRexxMsg(com,flags,arg0,arg1,arg2,...,argn)
 *      Es drfen maximal 15 Argumente bergeben werden. Weitere Argumente
 *      werden ignoriert. Will man nur 3 Argumente bergeben (arg1-arg3)
 *      bergibt man als letztes Argument (arg4) NULL
 *      Die Funktion gibt einen Zeiger auf die erstellte Message zurck,
 *      im Fehlerfalle NULL.
 */
   /*
    *      com ist der Name des aufzurufenden Kommandos.
    *      Alles Strings (com & args) sind normale mit NULL abgeschloene
    *      C-Strings.
    */
   /*
    *      action dieses Flag wir direkt im Command (action) Field
    *      der RexxMessage struktur eingefgt
    */
   /*
    *      first_arg is ein Zeiger auf das erste Argument (aufruf der
    *      Funktion s.o.
    *      Aufgrund der internen Handhabung wird nur der erste Parameter im
    *      Funktionskopf angenommen.
    *      Die Argumente sind normale 0-terminierte C-Strings
    */
   /*
    *      Weitere Argumente:
    */


/*****************************************************************/
/*      Dies Funktion gibt den Speicher einer RexxMessage frei.  */
/*      Also die Argumente, einen ggf vorhandenen ReturnWert     */
/*      und die Message selbst. Aus diesem Grund men Felder    */
/*      (Argumente und Return Code, wenn sie auerhalb der       */
/*      Funktion freigegeben worden sind auf NULL gesetzt werden */
/*****************************************************************/
   /* Zeiger auf die zu lschende RexxMessage */
   /*
    *      gibt TRUE fr Erfolg zurck
    */


/****************************************************************/
/*      PutRexxMsg schickt eine Message an den genannten Port   */
/*      un bernimmt die Buchfhrung ber fehlende Antworten    */
/****************************************************************/
   /*
    *      Port ist der Name des Ziel Ports. Der Name ist NULL beendeter
    *      String. Achtung !! kein PortPointer.
    *      Ist port NULL so wird die Message an den RexxHostPort geschickt.
    *      Da man einen eigenen Namen angeben kann, ist mglich, Messages
    *      direkt an andere Rexxfhige Programme zu senden.
    */
   /*
    *      rmsg    ist ein Zeiger auf gltige, vollstnig initialisierte
    *      RexxMessage-Struktur.
    */


/****************************************************************/
/*      GetRexxMsg funktioniert GetMsg des Betriebsystems,      */
/*      nur das ber die Messages Buchgefhrt wird              */
/****************************************************************/
/*
 *      Die Funktion gibt einen Zeiger auf die Message oder NULL
 *      zurck.
 *      Ist NULL ein Fehler, so kann das mit LastRexxError festgestellt
 *      werden. Sonst bedeutet es einfach, das keine Msg am Port
 *      wartet.
 */


/****************************************************************/
/*      FetchRexxMsg wartet bis eine Message an unserm          */
/*      Port ankommt und gibt diese zurck.                     */
/****************************************************************/
/*
 *      Die Funktion kehrt mit einem Zeiger auf die vom
 *      Port geholte Message zurck.
 */


/****************************************************************/
/*      ReplyRexxMsg    setzt den ArexxErrorCode, fllt den     */
/*      Returnwert_slot und beantwortet die Message.            */
/*      sollte es eine NonReply Message sein, so wird sie       */
/*      einfach gelscht                                        */
/****************************************************************/
/*
 *      Im falle eines Fehlers kehrt die Funktion mit FALSE zurck.
 *      Nhere Information kann man LastRexxError holen
 */
   /*
    *      rmsg    ist ein Zeiger auf die zu beantwortende Message
    */
   /*
    *      rexx_error ist ein Langwort, das den ArexxErrorCode enthlt.
    *      Der Code wird in das Result1 Fe ld der Message eingetragen.
    */
   /*
    *      return_string ist ein String, der als Return wert and den
    *      Caller zurckgegeben wird. ReplyRexxMsg generiert aus diesem
    *      C-String ein ArexxArgument un fllt dies in das Result2
    *      Feld ein.
    *      Ist rexx_error != 0, also ein Fehler aufgetreten, so wird der
    *      String ignoriert und das Feld auf NULL gesetz. Soll kein
    *      Returnwert zurckgegeben werden ist ein NULL-Pointer zu bergeben.
    */


/**********************************************************************/
/*      SyncRexxCommand sendet ein Kommando, und wartet bis das       */
/*      Kommando abgearbeitet ist. Sollten in der Zwischenzeit        */
/*      Kommandos an unser Port gehen, wird die Funktion              */
/*      process_message mit dem Zeiger auf die Message aufgerufen.    */
/*      So ist es mglich, whren eines SyncAufrufes Kommandos zu     */
/*      Empfangen. SyncRexxCommand untersttzt einen returncode.      */
/*      Dazu mu eine StringBuffer und die Gre des Buffer ber-     */
/*      geben werden .                                                */
/*      Der aufruf erfolgt:                                           */
/*      SyncRexxCommand(port,com,result,result_len,arg1,arg2,...,argn)*/
/*      Werden nicht alle Argumente genutzt, mu das letzte Argument  */
/*      NULL sein. Mehr als 15 Argumente werden ignoriert.            */
/**********************************************************************/
/*
 *      Die Funktion kehrt mit dem ArexxErrorCode oder dem Internen
 *      errorcode zurck.
 *      0 fr eine erfolgreiche aktion.
 *      Kommt es zu einem RexxFehler, so wird der ResultString gelscht.
 */
   /*
    *      port ist der Name des Ports an den das Kommando gesendet werden soll.
    *      wird als PortName 0 angegeben, so wird das Kommando an den Rexx-
    *      Host geschickt.
    */
   /*
    *      Com ist der String der den KommandoNamen enthlt
    */
   /*
    *      result ist ein Pointer auf den StringBuffer in den der
    *      ResultString des Kommandos kopiert werden soll. Ist result == NULL
    *      oder result_len == NULL so wird die Fukntion als Kommando
    *      ohne ReturnWert betrachtet, und die Flags in der RexxMsg
    *      entsprechend gesetzt.
    */
   /*
    *      first_arg Zeiger auf den ersten Argument String. Der aufruf Syntax
    *      ist oben beschrieben, und Funktioniert wie bei BuildRexxMessage.
    */
   /*
    *   weitere args
    */


/****************************************************************/
/*      RexxMessageHandler sucht die FunktionsListe durch, und  */
/*      ruft, falls es das Kommando gibt, die dazugehrige      */
/*      Funktion auf. Sollte das Kommando nicht existieren      */
/*      wird der ARexxFehlerCode Label NotFound zurckgegeben.  */
/****************************************************************/
/*
 * RexxMessageHandler ruft bei ankommenden Messages die in der
 * Funktionliste bergebenen Kommandos auf.
 *
 * --> rmsg     Zeiger auf die RexxMessage, die bearbeitet werden soll
 */


/****************************************************************/
/*      ChangeProcessMessage    ndert den Zeiger der process_  */
/*      message funktion.                                       */
/****************************************************************/
/*
 * ChangeProcessMessage ndert die Funktion fr das InterneMessagehandling
 *
 * --> new_function     Zeiger auf die neue Funktion, bei -1 wird
 *              der HRexx interne Handler verwendet
 * <-- RESULT   Pointer auf alten hndler
 */

/****************************************************************/
/*      SetRexxCommandTable  ndert die interne Kommandotabelle */
/****************************************************************/
   /*
    *      Zeiger auf eine vom Benutzer definierte Kommando Tabelle
    */
   /*
    *      gibt den Zeiger auf die alte Funktiontabelle zurck.
    */


/* Internal ErrorCodes */
#define  RERROR_AREXX_ALLREADY_OPEN      -1
#define  RERROR_OUT_OF_MEMORY            -2
#define  RERROR_NO_AREXX                 -3
#define  RERROR_PORT_ALLREADY_EXISTS     -4
#define  RERROR_INVALID_PORT_NAME        -5
#define  RERROR_NO_PORT                  -6
#define  RERROR_AREXX_NOT_OPEN           -7
#define  RERROR_INVALID_COMMAND_NAME     -8
#define  RERROR_UNKNOWN_DESTINATION_PORT -9
#define  RERROR_NO_MSG                   -10
#define  RERROR_STRING_TOO_LONG          -11
#define  RERROR_NO_COMMAND_TABLE         -12

struct  RexxCommand
{
   char *Name;
   long  (*Function)(char * _s,struct RexxMsg *rmsg);
};

/*************************************************************/
/*  ModifyRepCount  ndert Anzahl fehlender Messages         */
/*************************************************************/
/*
 ModifyRepCount
        ndert den Counter mit den fehlenden Messages um den in
        delta angegebenen Betrag.
        Der alte wert von RepCount wird zurckgegeben
*/

/*
 AttempCloseRexx
        probiert den ARexxPort zu schliessen (funktioniert nur, wenn
        OutstandingReplies==0 ist), kann das RexxSystem geschlossen
        werden kommt TRUE zurck, sonst False
*/


